#include <DHT11.h>

int pin=9;

DHT11 dht11(pin); 

const int trigPin = 2;    //Trig 핀 할당

const int echoPin = 4;    //Echo 핀 할당

const int LEFT_A1 = 5 ;

const int LEFT_B1 = 6 ;

const int RIGHT_A2 = 9 ;

const int RIGHT_B2 = 10;

 

 

int hum_pin = 7;

 

 

void setup()

{ 

  

    Serial.begin(9600);    //시리얼 초기화

    pinMode(trigPin, OUTPUT);    //Trig 핀 output으로 세팅

    pinMode(echoPin, INPUT);    //Echo 핀 input으로 세팅

 

   pinMode(LEFT_A1, OUTPUT);              // 5번핀을 출력모드로 설정합니다.

 

  pinMode(LEFT_B1, OUTPUT);              // 6번핀을 출력모드로 설정합니다.

 

  pinMode(RIGHT_A2, OUTPUT);             // 10번핀을 출력모드로 설정합니다.

 

  pinMode(RIGHT_B2, OUTPUT);  

  // rc카

 

 pinMode(hum_pin, OUTPUT);

  //가습기

     

}

 

void loop()

{

 


    long duration, distance;    


    digitalWrite(trigPin, LOW);        //Trig 핀 Low

    delayMicroseconds(2);            //2us 유지

    digitalWrite(trigPin, HIGH);    //Trig 핀 High

    delayMicroseconds(10);            //10us 유지

    digitalWrite(trigPin, LOW);        //Trig 핀 Low

 

    duration = pulseIn(echoPin, HIGH);     

 

    distance = duration / 29 / 2; 

   

 

    Serial.print(distance);

    Serial.print("cm");

    Serial.println();

 

 

 

   if(distance < 15) {        

     Serial.println("stop");

    int stop();  //정지(1초)

     Serial.println("backward");

    int backward();  //후진(0.5초)

     int rnd = random(0,2);   

     if(rnd == 0){

        Serial.println("right");

        right();

     }else{

        Serial.println("left");

        left();

     }

   }else{         //장애물 없음

     Serial.println("forward");

     forward();

   }

    

     //초음파

 delay(DHT11_RETRY_DELAY);

  //가습기

 digitalWrite(hum_pin, HIGH); 

 

   }

   

void forward(){

  digitalWrite(LEFT_A1, HIGH);

  digitalWrite(LEFT_B1, LOW);

  digitalWrite(RIGHT_A2, HIGH);

  digitalWrite(RIGHT_B2, LOW);

}

void backward(){

  digitalWrite(LEFT_A1, LOW);

  digitalWrite(LEFT_B1, HIGH);

  digitalWrite(RIGHT_A2, LOW);

  digitalWrite(RIGHT_B2, HIGH);

  delay(500);

}

void left(){

  digitalWrite(LEFT_A1, LOW);

  digitalWrite(LEFT_B1, HIGH);

  digitalWrite(RIGHT_A2, HIGH);

  digitalWrite(RIGHT_B2, LOW);

  delay(1000);

}

void right(){

  digitalWrite(LEFT_A1, HIGH);

  digitalWrite(LEFT_B1, LOW);

  digitalWrite(RIGHT_A2, LOW);

  digitalWrite(RIGHT_B2, HIGH);

  delay(1000);

}

void stop1(){

  digitalWrite(LEFT_A1, LOW);

  digitalWrite(LEFT_B1, LOW);

  digitalWrite(RIGHT_A2, LOW);

  digitalWrite(RIGHT_B2, LOW);

  delay(1000);

}
